#include <stdio.h>
#include <windows.h>
#include "ChildWindows.h"

#ifdef _MSC_VER
#define snprintf _snprintf_s
#endif

struct EnumChildProcArg_t {
        int style;
        int exstyle;
        vector<ChildInfo_t> * entries;
};
static BOOL CALLBACK EnumChildProc(HWND hwnd, LPARAM lParam);

ChildWindows::ChildWindows(
        const MkaeList_t * i_ilist, const int i_ilistlen,
        int i_style, int i_exstyle)
{
        style = i_style;
        exstyle = i_exstyle;

        const MkaeList_t * lim = (MkaeList_t *)((char *)(i_ilist) + i_ilistlen);
        for (const MkaeList_t * p = i_ilist; p < lim; p++) {

                // EnumChildProc֓n
                struct EnumChildProcArg_t args;
                args.style = style;
                args.exstyle = exstyle;
                args.entries = &entries;

                /* qEBhE
                 *   EnumChildProc ֐
                 *   http://msdn.microsoft.com/ja-jp/library/cc410835.aspx */
                EnumChildWindows(
                        p->hwnd_focused,
                        (WNDENUMPROC)EnumChildProc,
                        (LPARAM)&args);

        } // for(i_ilist)
}

ChildWindows::~ChildWindows()
{
        vector<ChildInfo_t>::iterator itc;
        for (itc = entries.begin(); itc != entries.end(); itc++) {
                DestroyIcon(itc->hicon);
        }
}

BOOL CALLBACK
EnumChildProc(
        HWND hwnd,              // qEBhẼnh
        LPARAM lParam)          // AvP[V`̒l
{
        struct EnumChildProcArg_t * args = (struct EnumChildProcArg_t *)lParam;

	int style = GetWindowLong(hwnd, GWL_STYLE);
        if ((style & args->style) != args->style)
                // LvV̖͑ΏۊO
                return TRUE;

	int exstyle = ::GetWindowLong(hwnd, GWL_EXSTYLE);
        if ((exstyle & args->exstyle) != args->exstyle)
                // MDI child̖͑ΏۊO
                return TRUE;

        char txt[MAX_WINTEXT];
        memset(txt, 0, sizeof(txt));
        GetWindowText(hwnd, txt, sizeof(txt));

	// ACR:l_icon_s 擾
        HICON hicon_s;
        DWORD result;
        hicon_s = (HICON)::GetClassLong(hwnd, GCL_HICONSM); //Iconnh擾
        if (0 == hicon_s) {
                if (::SendMessageTimeout(
                            hwnd, WM_GETICON, ICON_SMALL, NULL,
                            SMTO_ABORTIFHUNG | SMTO_BLOCK,
                            100, &result)) {
                        hicon_s = (HICON)result;
                }
        }

        // Zbg
        ChildInfo_t info;
        info.hwnd = hwnd;
        info.hicon = hicon_s;
        snprintf(info.caption, sizeof(info.caption), "%s", txt);
        args->entries->push_back(info);

        return TRUE;            // 񋓂𑱍s
}

