//
// ChildListvOC̃\[Xt@CłB
//
//---------------------------------------------------------------------------
#if !defined(_DEBUG) && !defined(NDEBUG)
#define NDEBUG
#endif
#include <assert.h>

#include <stdio.h>
#include <windows.h>

#ifdef _MSC_VER
#define snprintf _snprintf_s
#define strncpy(d,s,n) strcpy_s(d,n,s)
#endif

// plugin include file --------------
#include "../Plugin.h"
#include "../MkaeApi.h"

// my include file
#include "ChildWindows.h"

// global variables -----------------
HINSTANCE g_hinst;
HWND g_hwnd;
const char * g_classname  = "MadokaeDll_ChildList";
const char * g_pluginname = "ChildList";
char g_inifname[_MAX_PATH+2]; // `ۑpInit@C

MkaeAPI g_MkaeApi;
unsigned int g_customlist_uid = 0;

MkaePluginMenu_t g_mymenu[] = {
        {1, 0, "MDIqEBhE\(&T)",       "", "MyToggleEnable",  ""},
};

struct orglist_t {
        char * buf;
        int len;
};
struct orglist_t g_orgmlist;
struct orglist_t g_orgclist;

ChildWindows * g_childwindows = NULL;

struct Features_t {
        int is_enable;

        // ΏۂɂEBhEX^C.
        // w肵X^C̂Xg֍ڂ
        int child_style;
        int child_exstyle;

        char enable_shortcut[MAX_SHORTCUT];
} g_fea;

#define DEFAULT_CHILD_STYLE   (WS_CAPTION)
#define DEFAULT_CHILD_EXSTYLE (WS_EX_MDICHILD)

// static function prototypes -------
int  DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved);
void DllProcessDetach(LPVOID lpvReserved);

// callback -------------------------
extern "C" __declspec(dllexport) void __stdcall MyToggleEnable(const char *);

extern "C" __declspec(dllexport) int  __stdcall MyNewCustomList(
        const MkaeList_t *, const int,
        const MkaeCustomList_t *, const int);
extern "C" __declspec(dllexport) void __stdcall MyGetCustomList(
        MkaeList_t * o_omlist, const int i_omlistlen,
        MkaeCustomList_t * o_oclist, const int i_oclistlen);
extern "C" __declspec(dllexport) void __stdcall MyDeleteCustomList(void);

static void MySetForegroundWindow(HWND i_hwnd);

//---------------------------------------------------------------------------
// DllMain
//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        switch (fwdreason) {
        case DLL_PROCESS_ATTACH: {
                if (0 != DllProcessAttach(hinstDLL, lpvReserved))
                        return 0; // error
                break;
        }
        case DLL_THREAD_ATTACH:
                break;
        case DLL_THREAD_DETACH:
                break;
        case DLL_PROCESS_DETACH:
                DllProcessDetach(lpvReserved);
                break;
        } // end of switch(fwdreason)
        return 1;
}
//---------------------------------------------------------------------------
 
int
DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved)
{
        g_hinst = (HINSTANCE) hinstDLL;

        // APIL
        if (false == g_MkaeApi.IsEnable())
                return -1; // error

        // ւ̃o[W擾 (菈͖쐬)
        char version[80];
        g_MkaeApi.GetVersion(version, sizeof(version));

        // <vOC>.ini ̍쐬
        char mdlname[_MAX_PATH+2]; // module name
        GetModuleFileName((HINSTANCE)hinstDLL, mdlname, _MAX_PATH);
        LPSTR pext = strrchr(mdlname, '.');
        if (pext) *pext = '\0';
        snprintf(g_inifname, sizeof(g_inifname), "%s.ini", mdlname);

        return 0;
}

void
DllProcessDetach(LPVOID lpvReserved)
{
        // nothing to do
}

//---------------------------------------------------------------------------
// R[obN֐ (K{֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
Mkae_OnGetPluginInfo(MkaePluginInfo_t * o_info)
{
        memset(o_info, 0x0, sizeof(*o_info));
        strncpy(o_info->name, g_pluginname, (sizeof(o_info->name)-1));
}

//---------------------------------------------------------------------------
// R[obN֐ (Cӊ֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall
Mkae_OnSetup(HWND i_hwnd_owner)
{
        g_fea.is_enable =
                ::GetPrivateProfileInt("General", "Enable", 1, g_inifname);
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false; // j[ɔfĂ

        g_fea.child_style =
                ::GetPrivateProfileInt(
                        "Filter", "ChildStyle", 
                        DEFAULT_CHILD_STYLE, g_inifname);
        g_fea.child_exstyle =
                ::GetPrivateProfileInt(
                        "Filter", "ChildExStyle", 
                        DEFAULT_CHILD_EXSTYLE, g_inifname);

        // V[gJbgL[
        ::GetPrivateProfileString(
                "ShortcutKey", "ToggleEnable", "",
                g_fea.enable_shortcut, sizeof(g_fea.enable_shortcut),
                g_inifname);

        if (g_fea.is_enable) {
                if (0 != g_MkaeApi.RegisterCustomList(
                            MyNewCustomList,
                            MyGetCustomList,
                            MyDeleteCustomList,
                            &g_customlist_uid))
                        g_customlist_uid = 0; // set error
        }

        // ̃Xgi[̈
        g_orgmlist.buf = NULL;
        g_orgmlist.len = 0;
        g_orgclist.buf = NULL;
        g_orgclist.len = 0;
                
        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupRootMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // KvȂ, Mkae_OnSetupSubMenu() ̗lɏ.
        // svȂ, ֐ƍ폜.
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupSubMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // vfԂ
        *o_count = (sizeof(g_mymenu) / sizeof(g_mymenu[0]));

        if (o_menu != NULL) {
                // o_menuNULLłȂΓe

                // shortcutkeyݒ
                snprintf(g_mymenu[0].shortcut, sizeof(g_mymenu[0].shortcut), 
                         "%s", g_fea.enable_shortcut);
                // j[copy
                memcpy(o_menu, &g_mymenu, sizeof(g_mymenu));

                g_MkaeApi.UpdateList();
        }
}

extern "C" __declspec(dllexport) int __stdcall
Mkae_OnTeardown()
{
        if (g_orgmlist.buf) {
                // Xgi[̈悪ĂȂ̂ 
                free(g_orgmlist.buf);
                g_orgmlist.buf = NULL;
                g_orgmlist.len = 0;
        }
        if (g_orgclist.buf) {
                // Xgi[̈悪ĂȂ̂ 
                free(g_orgclist.buf);
                g_orgclist.buf = NULL;
                g_orgclist.len = 0;
        }

	if (g_customlist_uid)
	        g_MkaeApi.UnregisterCustomList(g_customlist_uid);

        // init@C֐ݒo
        char work[20];
        snprintf(work, sizeof(work), "%d", g_fea.is_enable);
        ::WritePrivateProfileString("General", "Enable", work, g_inifname);

        snprintf(work, sizeof(work), "%d", g_fea.child_style);
        ::WritePrivateProfileString("Filter", "ChildStyle", work, g_inifname);
        snprintf(work, sizeof(work), "%d", g_fea.child_exstyle);
        ::WritePrivateProfileString("Filter", "ChildExStyle", work, g_inifname);

        // ShortcutKey ......................
        ::WritePrivateProfileString(
                "ShortcutKey", "ToggleEnable", g_fea.enable_shortcut, g_inifname);

        return 0;
}


//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
MyToggleEnable(const char * i_cmdargs)
{
        g_fea.is_enable = (g_fea.is_enable) ? 0 : 1;
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false;
        g_MkaeApi.ReloadMenu(g_pluginname);

	if (g_customlist_uid) {
	        g_MkaeApi.UnregisterCustomList(g_customlist_uid);
		g_customlist_uid = 0;

        } else if (g_fea.is_enable) {
                if (0 != g_MkaeApi.RegisterCustomList(
                            MyNewCustomList,
                            MyGetCustomList,
                            MyDeleteCustomList,
                            &g_customlist_uid)) {
                        g_customlist_uid = 0; // set error
                        return;
                }
        }
        g_MkaeApi.UpdateList();
}

extern "C" __declspec(dllexport) int  __stdcall
MyNewCustomList(
        const MkaeList_t * i_imlist, const int i_imlistlen,
        const MkaeCustomList_t * i_iclist, const int i_iclistlen)
{
        assert(!g_childwindows);

        int nclist;             // Gg(Ԃl)

        // ̃Xgi[̈j
        if (g_orgmlist.buf) {
                free(g_orgmlist.buf);
                g_orgmlist.buf = NULL;
                g_orgmlist.len = 0;
        }
        if (g_orgclist.buf) {
                free(g_orgclist.buf);
                g_orgclist.buf = NULL;
                g_orgclist.len = 0;
        }

        // Xgi[̈mۂ,ۑĂ
        g_orgmlist.len = i_imlistlen;
        g_orgmlist.buf = (char *)malloc(g_orgmlist.len);
        if (g_orgmlist.buf)
                memcpy(g_orgmlist.buf, (char *)i_imlist, g_orgmlist.len);

        g_orgclist.len = i_iclistlen;
        g_orgclist.buf = (char *)malloc(g_orgclist.len);
        if (g_orgclist.buf)
                memcpy(g_orgclist.buf, (char *)i_iclist, g_orgclist.len);

        // ̃JX^Xg
        nclist = i_iclistlen / sizeof(MkaeCustomList_t);

        if (g_fea.is_enable) {
                // MDIqEBhE XgNX
                g_childwindows = 
                        new ChildWindows(
                                i_imlist, i_imlistlen,
                                g_fea.child_style,
                                g_fea.child_exstyle);
                nclist += (int)g_childwindows->entries.size();
        }

        return nclist;
}

extern "C" __declspec(dllexport) void __stdcall
MyGetCustomList(
        MkaeList_t * o_omlist, const int i_omlistlen,
        MkaeCustomList_t * o_oclist, const int i_oclistlen)
{
        assert(g_orgmlist.len <= i_omlistlen);
        assert(g_orgclist.len <= i_oclistlen);

        // ̃XgRs[
        memcpy(o_omlist, g_orgmlist.buf, g_orgmlist.len);
        memcpy(o_oclist, g_orgclist.buf, g_orgclist.len);

        // ^XNgC,qEBhEǉĂ
        MkaeCustomList_t * p =
                (MkaeCustomList_t *)((char *)o_oclist + g_orgclist.len);
        MkaeCustomList_t * lim =
                (MkaeCustomList_t *)((char *)o_oclist + i_oclistlen);

        if (g_childwindows) {
                vector<ChildInfo_t>::iterator itc;
                for (itc = g_childwindows->entries.begin();
                     itc != g_childwindows->entries.end(); itc++) {
                        if (p >= lim)
                                break;
                        p->hwnd = itc->hwnd;
                        snprintf(p->caption, sizeof(p->caption),
                                 "%s", itc->caption);
                        p->hicon_s = itc->hicon;
                        p++;
                }
        }
}

extern "C" __declspec(dllexport) void __stdcall
MyDeleteCustomList(void)
{
        // MDIqEBhE XgNXj
        if (g_childwindows) {
                delete g_childwindows;
                g_childwindows = NULL;
        }
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnWindowActive(const HWND i_hwnd)
{
        if (NULL == g_orgmlist.buf) 
                // Xg񂪂ȂΉoȂ
                return;

        MkaeList_t * lim = (MkaeList_t *)((char *)g_orgmlist.buf + g_orgmlist.len);
        for (MkaeList_t *p = (MkaeList_t *)g_orgmlist.buf; p < lim; p++) {
                if (p->hwnd_focused == i_hwnd)
                        // Xgɑ݂Ȃ,
                        // dllŒǉ̂ł͂Ȃ̂ŉȂ
                        return;
        }

        // ؂ւw肳ꂽEBh̐eEBhET
        HWND hwnd = i_hwnd;
        HWND hwnd_parent = ::GetParent(hwnd); 
        while (hwnd_parent != NULL) {
                // hwnd_parent  NULLɂȂ܂ŉ
                // ꂪԏ = eEBhEƂȂ
                hwnd = hwnd_parent;
                hwnd_parent = ::GetParent(hwnd);
        }
        assert(hwnd);

        MySetForegroundWindow(i_hwnd);
        if (IsIconic(hwnd)) {
                // ɖ߂
                DWORD result;
                ::SendMessageTimeout(
                        hwnd, WM_SYSCOMMAND, SC_RESTORE, 0,
                        SMTO_ABORTIFHUNG | SMTO_NORMAL, 100, &result);

                // ACRĂ,
                // i_hwnd ւ̃ANeBusĂ̂
                // ēx qEBhE ANeBu
                MySetForegroundWindow(i_hwnd);
        }
        return;
}

/* 
 * gforegroundɏo.
 */
void MySetForegroundWindow(HWND i_hwnd)
{
        // Thread̃Cvbg̃A^b`
        int self_tid, active_tid;
	active_tid = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
        self_tid = ::GetCurrentThreadId();
        ::AttachThreadInput(self_tid, active_tid, TRUE);

        // ACRԂȂ畜
	if (::IsIconic(i_hwnd)) {
                DWORD result;
                ::SendMessageTimeout(
                        i_hwnd, WM_SYSCOMMAND, SC_RESTORE, 0, 
                        SMTO_ABORTIFHUNG | SMTO_NORMAL, 100, &result);
        }

        // ZorferɎĂ
        ::SetForegroundWindow(i_hwnd); // tHAOEhɎĂ

        // Thread؂藣
        ::AttachThreadInput(self_tid, active_tid, FALSE);
}
